/*
 *  OpenGLDraw2D.cpp
 *  SampleScreenSaver
 *
 *  Created by гык-sse2 on 11.07.10.
 *  Copyright 2010 Гимназия 1542. All rights reserved.
 *
 */
#include "stdafx.h"

#include "consolation.h"
#ifdef __APPLE__
	#include <GLUT/glut.h>
	#include "SDL.h"
#else
#ifdef WIN32
	#include "SDL.h"
	#include <stdio.h>
	#include "glut.h"
#else
	#include <GL/glut.h>
	#include "SDL/SDL.h"
#endif
#endif
#include <math.h>
#include <stdarg.h>

SDL_Surface* gScreen;
#define		pi			3.1415

GLvoid*		font_style				=GLUT_BITMAP_8_BY_13;
PTFillStyle	fillStyle;
PTColor		fillColor;
PTColor		drawColor;
PTColor		backColor;
int			x=0;
int			y=13;
int			hsize;
int			vsize;
char		symbol;
bool		keyWasPressed=false;
int			keyScanCode;
int			keyUnicode;


void initgraph (int hsize, int vsize, bool fullscreen) {
	::hsize=hsize;
	::vsize=vsize;
	
	if ( SDL_Init (SDL_INIT_VIDEO) < 0 ) 		
        exit(1);
	SDL_InitSubSystem(SDL_INIT_TIMER);
	SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 16);
    
    Uint32 flags = SDL_OPENGL;
    if (fullscreen)
        flags |= SDL_FULLSCREEN;  		
	
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 0);
    gScreen = SDL_SetVideoMode (hsize, vsize, 32, flags);
	
    if (!gScreen) {		
        SDL_Quit();
		exit(2);
	}
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glOrtho (0, hsize, vsize, 0, 0, 1);
	glDisable(GL_DEPTH_TEST);
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity();
	// Displacement trick for exact pixelization
	glTranslatef(0.375, 0.375, 0);
	setbkcolor(BLACK);
	setcolor(WHITE);
	setfillstyle(SOLID_FILL, WHITE);
	
	ptprintf("%s","This project is using Consolation - Paztalom Technologiez console emulation and graphics library");
	delay(1000);
	clrscr();
}

void closegraph(){
	SDL_Quit();
}

void cleardevice () {
	switch(backColor){
		case BLACK:
			glClearColor(0,0,0,0);
			break;
		case GREEN:
			glClearColor(0,1,0,0);
			break;
		case BLUE:
			glClearColor(0, 0, 1,0);
			break;
		case YELLOW:
			glClearColor(1,1,0,0);
			break;
		case DARKGRAY:
			glClearColor(0.33,0.33,0.33,0);
			break;
		case WHITE:
			glClearColor(1,1,1,0);
			break;
		case RED:
			glClearColor(1,0,0,0);
			break;
	}
	glClear(GL_COLOR_BUFFER_BIT);	
	glFlush();
}



void putpixel(float x1, float y1){
	setcolor(drawColor);
	glBegin(GL_POINTS);
	glVertex2f(x1, y1);
	glEnd();
	glFlush();
}

void line(float x1,float y1,float x2,float y2){
	setcolor(drawColor);
	glBegin(GL_LINES);
	glVertex2f(x1, y1); glVertex2f(x2, y2);
	glEnd();
	glFlush();
}

void bar(float x1,float y1,float x2,float y2){
	PTColor backupColor=drawColor;
	switch(fillStyle) {
		case SOLID_FILL:
			setcolor(fillColor);
			glBegin(GL_QUADS);
			glVertex2f(x1, y1); glVertex2f(x2, y1); glVertex2f(x2, y2); glVertex2f(x1, y2);
			glEnd();
			break;
		case NONE:
		default:
			break;
	}
	setcolor(backupColor);
	glBegin(GL_LINE_LOOP);
	glVertex2f(x1, y1); glVertex2f(x2, y1); glVertex2f(x2, y2); glVertex2f(x1, y2);
	glEnd();
	glFlush();
}

void fillpoly(int n, float* array){
	PTColor backupColor=drawColor;
	switch(fillStyle){
		case SOLID_FILL:
			setcolor(fillColor);
			glBegin(GL_POLYGON);
			for (int i=0; i<n; i++) 
				glVertex2f(array[2*i], array[2*i+1]);
			glEnd();
			break;
		case NONE:
		default:
			break;
	}
	setcolor(backupColor);
	glBegin(GL_LINE_LOOP);
	for (int i=0; i<n; i++) 
		glVertex2f(array[2*i], array[2*i+1]);
	glEnd();
	glFlush();
}

void outtextxy (float x, float y, const char* string) {
	::x=x;
	::y=y;
	outtext(string);
}

void outtext (const char* string) {
	setcolor(drawColor);
	glRasterPos2f(x, y);
	GLvoid		*font_style	=GLUT_BITMAP_8_BY_13;
	for (int i = 0; string[i] != '\0'; i++) {
		switch (string[i]) {
			case '\n':
				if (y+13<vsize) {
					x=0;
					y+=13;
				}
				else 
					clrscr();
				break;
			case '\r':
				x=0;
				break;
			default:
				glutBitmapCharacter(font_style, string[i]);
				if (x+8<hsize)
					x+=8;
				else if(y+13<vsize) {
					x=0;
					y+=13;
				}else
					clrscr();
				glRasterPos2f(x, y);				
		}		
	}
	glFlush();
}

void gotoxy (float x, float y) {//Coordinates in Symbols, not in Pixels
	::x=8*x;
	::y=13*y;
	glRasterPos2f (::x, ::y);
}

void setfillstyle(PTFillStyle newStyle, PTColor newColor) {
	fillStyle=newStyle;
	fillColor=newColor;
}

void fillellipse(float x0, float y0, float r1, float r2) {
    float x, y;
	PTColor backupColor=drawColor;
	switch (fillStyle) {
		case SOLID_FILL:
			setcolor(fillColor);
			glBegin(GL_TRIANGLE_FAN);
			glVertex2f(x0, y0);
			for(int i = 0; i < 360.0; i++) {
				x = x0+r1 * sin(i/360.0 * pi*2.0);
				y = y0+r2 * cos(i/360.0 * pi*2.0);
				glVertex2f(x, y);
			}
			glEnd();
			setcolor(backupColor);
			break;
		case NONE:
		default:			
			break;
	}
	glBegin(GL_LINE_LOOP);
	for(int i = 0; i < 360.0; i++) {
        x = x0+r1 * sin(i/360.0 * pi*2.0);
        y = y0+r2 * cos(i/360.0 * pi*2.0);
        glVertex2f(x, y);
    }
	glEnd();
	glFlush();
}

void setbkcolor (PTColor color){
	backColor=color;
	cleardevice();
}

void setcolor (PTColor color){
	drawColor=color;
	switch(color){
		case BLACK:
			glColor3f(0,0,0);
			break;
		case GREEN:
			glColor3f(0,1,0);
			break;
		case BLUE:
			glColor3f(0, 0, 1);
			break;
		case YELLOW:
			glColor3f(1,1,0);
			break;
		case DARKGRAY:
			glColor3f(0.33,0.33,0.33);
			break;
		case WHITE:
			glColor3f(1,1,1);
			break;
		case RED:
			glColor3f(1,0,0);
			break;
	}
}


void clrscr () {
	cleardevice();
	x=0;
	y=13;
}

char getch () {
	SDL_Event event;
	SDL_EnableUNICODE(SDL_ENABLE);
	do SDL_WaitEvent(&event);
	while ((event.type!=SDL_KEYDOWN)||!(event.key.keysym.unicode));
	SDL_EnableUNICODE(SDL_DISABLE);
	return event.key.keysym.unicode;
}

char getche () {
	char c=getch();
	if ((c!='\r')&&(c!='\n'))
		putch(c);
	return c;
}

int putch (char symbol) {
	setcolor(drawColor);
	glRasterPos2f(x, y);	
    glutBitmapCharacter(font_style, symbol);
	if (x+8<hsize)
		x+=8;
	else {
		x=0;
		y+=13;
	}
	glFlush();
	return 0;
}

int ptputs (const char* string) {
	outtextxy(x, y, string);
	x=0;
	if (y+13<vsize)
		y+=13;
	else
		clrscr();
	return 0;
}

char* ptgets (char* string) {
	int i=0;
	do {
		string[i]=getche();
		i++;
	} while ((string[i-1]!='\r')&&(string[i-1]!='\n'));
	string[i-1]='\0';
	x=0;
	if (y+13<vsize)
		y+=13;
	else
		clrscr();
	return string;
}

void catchevents () {
	SDL_Event event;
	SDL_EnableUNICODE(SDL_ENABLE);
	SDL_PollEvent(&event);
	switch (event.type) {
		case SDL_KEYDOWN:
			keyWasPressed=true;
			keyScanCode=event.key.keysym.scancode&0x7f;
			keyUnicode=event.key.keysym.unicode&0x7f;
			putch(keyUnicode);
			break;
		case SDL_QUIT:
			closegraph();
			exit(0);
			break;
		default:
			break;
	}
	SDL_EnableUNICODE(SDL_DISABLE);
}

int bioskey(int command) {
	SDL_Event event;
	SDL_EnableUNICODE(SDL_ENABLE);
	uint32_t k=0;
	switch (command) {
		case 0:
			if (keyWasPressed){
				keyWasPressed=false;
				k=(keyScanCode<<8)||keyUnicode;
			}
			do SDL_WaitEvent(&event);
			while (event.type!=SDL_KEYDOWN);
			SDL_EnableUNICODE(SDL_DISABLE);
			k=((event.key.keysym.scancode&0x7f)<<8)|(event.key.keysym.unicode&0x7f);
			break;
		case 1:
			if (keyWasPressed)
				k=(keyScanCode<<8)||keyUnicode;
			break;
		case 2:
		default:
			break;
	}
	SDL_EnableUNICODE(SDL_DISABLE);
	return k;
}

void PTPointArray (float* array, int n) {
	setcolor(drawColor);
	glBegin(GL_POINTS);
	for (int i=0; i<n; i++)
		glVertex2f(array[2*i], array[2*i+1]);
	glEnd();
	glFlush();
}

void PTLinedPointArray (float* array, int n) {
	setcolor(drawColor);
	glBegin(GL_LINE_STRIP);
	for (int i=0; i<n; i++)
		if (array[2*i]&&array[2*i+1])
			glVertex2f(array[2*i], array[2*i+1]);
	glEnd();
	glFlush();
}

void	ptprintf		(const char* format, ...){
	va_list ap;
	va_start(ap, format);
#ifdef WIN32
	int len = _vscprintf(format, ap)+1;
	char* string = new char[len];
   	vsprintf(string, format, ap);
#else
	char* string;
	vasprintf(&string, format, ap);
#endif
	glRasterPos2f (x, y);
	outtext(string);
	delete[] string;
}

#ifndef WIN32
void ptscanf (const char* format, ...){
	va_list ap;
	va_start(ap, format);
	char* string=new char[80];
	ptgets(string);
	vsscanf(string, format, ap);
	delete[] string;
}
#endif

void bar3d (float x1, float y1, float x2, float y2, float depth, bool topflag){
	bar(x1,y1,x2,y2);
	if (topflag) {
		glBegin(GL_LINE_STRIP);
		glVertex2f(x1,			y1);
		glVertex2f(x1+depth,	y1-depth*tan(pi*36.0/180.0));
		glVertex2f(x2+depth,	y1-depth*tan(pi*36.0/180.0));
		glVertex2f(x2+depth,	y2-depth*tan(pi*36.0/180.0));
		glVertex2f(x2,			y2);
		glEnd();
		glBegin(GL_LINES);
		glVertex2f(x2,			y1);
		glVertex2f(x2+depth,	y1-depth*tan(pi*36.0/180.0));
		glEnd();
	}
	else {
		glBegin(GL_LINES);
		glVertex2f(x2,			y2);
		glVertex2f(x2+depth,	y2-depth*tan(pi*36.0/180.0));
		glEnd();
	}

	glFlush();
}

void delay(int ms){
	SDL_Delay(ms);
}
